#!/usr/bin/python

import sys

ld_file = sys.argv[1]
start = int(sys.argv[2])
end = int(sys.argv[3])
matrix = sys.argv[4]
snp_file = sys.argv[5] 

ld_dict = {}
snp1_list = []
snp2_list = []
infile = open(ld_file, "r")
num = 0
for line in infile:
    line = line.strip("\n\r")
    ele = line.split(" ")
    if num > 0:
        flt = [i for i in ele if i != ""]
        pos1 = int(flt[1])
        pos2 = int(flt[4])
        r2 = flt[6]
        if pos1 >= start and pos1 <= end and pos2 >= start and pos2 <= end:
            temp = "%d\t%d" % (pos1, pos2)
            if temp not in ld_dict:
                ld_dict[temp] = r2
            else:
                print "%s occurred twice" % temp
            if pos1 not in snp1_list:
                snp1_list.append(pos1)
            if pos2 not in snp2_list:
                snp2_list.append(pos2)
    num +=1
    if num % 1000000 == 0:
        print num
infile.close()
print "ld file loaded"

snp1_list.sort()
snp2_list.sort()
## add first snp to snp2_list
## add last snp to snp1_list
snp1_list.append(snp2_list[-1])
snp2_list.append(snp1_list[0])
snp1_list.sort()
snp2_list.sort()

print len(snp1_list)
print len(snp2_list)
if snp1_list != snp2_list:
    print "not all pairs are included"
    for snp in snp1_list:
        if snp not in snp2_list:
            print "%d in snp1_list but not in snp2_list" % snp
    for snp in snp2_list:
        if snp not in snp1_list:
            print "%d in snp2_list but not in snp1_list" % snp
else:
    outfile = open(matrix, "w")
    for snp1 in snp1_list:
        outlist = []
        for snp2 in snp2_list:
            tag = "%d\t%d" % (snp1, snp2)
            if tag in ld_dict:
                outlist.append(ld_dict[tag])
            else:
                if snp1 == snp2:
                    outlist.append("1")
                else:
                    outlist.append("-1")
        outfile.write("\t".join(outlist) + "\n")
outfile.close()

snp_list = [str(k) for k in snp1_list]
outfile = open(snp_file, "w")
outfile.write("\n".join(snp_list))
outfile.close()