#!/usr/bin/python

### calculate per site Pi and theta

import sys

vcf_file = sys.argv[1]
ind_file = sys.argv[2]
div_file = sys.argv[3]


def count_allele(geno_list):## count number of reference and alternative alleles
    temp = [i[0] for i in geno_list] + [i[2] for i in geno_list]
    ref = temp.count("0")
    alt = temp.count("1")
    return[ref, alt]
    

### load sample list analyses
infile = open(ind_file, "r")
ind_list = []
for line in infile:
    line = line.strip("\n\r")
    ele = line.split("\t")
    ind_list.append(ele[0])
infile.close()


outfile = open(div_file, "w")
outfile.write("Sca\tPos\tref\talt\tN\tPi\ttheta\tSeg\tSingle")

### load vcf file, calculate pi and theta
infile = open(vcf_file, "r")
pos_list = []
for line in infile:
    line = line.strip("\n\r")
    ele = line.split("\t")
    if line[:6] == "#CHROM":## get position of samples
        for i in range(len(ele)):
            if ele[i] in ind_list:
                pos_list.append(i)
    if line[0] != "#":
        geno_list = [ele[i] for i in pos_list]### genotype list of pop1
        info = count_allele(geno_list)
        ref = info[0]
        alt = info[1]
        n = ref + alt
        if (1.0 * n) /(len(geno_list)*2) >= 0.5:##missing < 0.5
            if ref * alt != 0:
                S = 1
            else:
                S = 0
            pi = round((2.0 * ref * alt/(n*(n -1))),4)
            i  = 1
            temp = 0
            while i <= n:
                temp += 1.0/i
                i +=1
            theta = round((S/temp),3)
            single = "No"
            if min([ref, alt]) == 1:##check if singleton
                single = "Yes"
            List = [ele[0], ele[1], ele[3], ele[4], str(n), str(pi), str(theta), str(S), single]
            outfile.write("\n" + "\t".join(List))
infile.close()
outfile.close()